#pragma once

// system includes
#include <limits>

// esp-idf includes
#include <esp_system.h>

namespace espcpputils {

class esp_random_device
{
public:
    using result_type = decltype(esp_random()); // should be uint32_t

    result_type operator()() const { return esp_random(); }

    double entropy() const { return 1.; }
    static result_type min() { return std::numeric_limits<result_type>::min(); }
    static result_type max() { return std::numeric_limits<result_type>::max(); }
};

} // namespace espcpputils
